Subject: Re: [PATCH 0/3] extend --ignore-other-worktrees to 'rebase', add hints

From: Ben Knoble <[email-masked]>
Date: Sat, 13 Sep 2025 15:30:42 -0400

> Le 13 sept. 2025 à 10:13, Gabriel Scherer <[email-masked]> a écrit :
> 
> The old 'workdir' contribution script was removed from git upstream in May
> 2025, as it is largely superseded by the 'worktree' command.
> 
> One significant difference between the old script and the command is that
> 'git' refuses to checkout or rebase branches that are already checked out in
> another worktree. My understanding of the reasoning is that users may be
> surprised when a clean worktree becomes dirty as its index is changed from
> another worktree. However, this safety net adds a mental burden to worktree
> users, as they have to keep the other worktrees in mind when moving
> branches. Old goats like me who are used to the old 'workdir' script find
> this restriction somewhat painful.
> 
> See the discussion thread
>  https://lore.kernel.org/git/[email-masked]/
> about this transition.
> 
> The present patch series tries to provide a smoother migration path for
> supporters of worktree independence:
> 
> - when 'checkout' refuses because the branch is used in another worktree,
>   display a 'hint' that mentions the possibility of using '--detach'
>   instead, and the '--ignore-other-worktrees' option to proceed anyway.
> 
> - add support for '--ignore-other-worktrees' in 'rebase' as well, with
>   a similar hint.
> 
> In the future I would be interested in adding an option
> 'branch.ignoreOtherWorktrees' to be able to ignore other worktrees globally.
> 
> Note: this is my first experience submitting a patch to the Git project, so
> I apologize in advance for any mishap and welcome beginner-level feedback.

I’m eager to see further reviews, but nothing I saw in this series stuck out as a major problem. I saw we updated the rebase test cases; should we add some more for checkout or worktree?